Attribute VB_Name = "Module1"
Option Explicit

Public Type myData
    data() As Byte
End Type

Public shiftCount As Integer
Public elements As Integer
Public hFile As Long
Public PEOffset As Integer
Public RESOffset As Integer
Public icons() As myData
Public iconNames() As String
Public iconHeaders() As myData
Public iconData() As myData

Public Sub LookHex(file As String)
Dim i As Integer
Dim magicNumber As Integer
Dim offset As Integer
Dim bytes() As Byte
Dim s() As String
    hFile = FreeFile
    Open file For Binary Access Read As hFile
    Get hFile, &H3D, PEOffset
    Get hFile, PEOffset + 1, magicNumber
    If magicNumber = &H454E Then
        Get hFile, PEOffset + &H24 + 1, RESOffset
        RESOffset = RESOffset + PEOffset
        Get hFile, RESOffset + 1, shiftCount
        shiftCount = 2 ^ shiftCount
        Get hFile, RESOffset + 4 + 1, elements
        iconNames = GetStringtable
        iconHeaders = GetIconHeaders
        iconData = GetIconData
        icons = GetIcons
        Call GetNames
    End If
    Close hFile
    s = GetNames
    Form1.Label1.Caption = elements & " Icons gefunden!"
    Form1.List1.Clear
    For i = 0 To UBound(s)
        Form1.List1.AddItem s(i)
    Next i
End Sub

Public Function GetIcons() As myData()
Dim i As Integer
Dim j As Integer
Dim icons() As myData
    ReDim icons(elements)
    For i = 0 To elements - 1
        ReDim icons(i).data(&H16 + UBound(iconData(i).data))
        For j = 0 To UBound(iconHeaders(i).data) - 1
            icons(i).data(j) = iconHeaders(i).data(j)
        Next j
        For j = 0 To UBound(iconData(i).data) - 1
            icons(i).data(&H16 + j) = iconData(i).data(j)
        Next j
    Next i
    GetIcons = icons
End Function

Public Function GetIconData() As myData()
Const LENGTH = &HC
Dim zw As Long
Dim data() As myData
Dim MAINoffset As Integer
Dim offset As Integer
Dim lengths() As Integer
Dim i As Integer
    ReDim data(elements - 1)
    ReDim lengths(elements - 1)
    MAINoffset = RESOffset + (elements + 1) * LENGTH
    For i = 0 To elements - 1
        Get hFile, MAINoffset + &H6 + i * LENGTH + 1 + 2, lengths(i)
        Get hFile, MAINoffset + &H6 + i * LENGTH + 1, offset
        ReDim data(i).data(lengths(i) * shiftCount - 1)
        If offset < 0 Then
            zw = 2 * 32768 + offset
        Else
            zw = offset
        End If
        zw = zw * shiftCount + 1
        Get hFile, zw, data(i).data
    Next i
    GetIconData = data
End Function

Public Function GetIconHeaders() As myData()
Const LENGTH = &HC
Dim zw As Long
Dim offset As Integer
Dim headers() As myData
Dim lengths() As Integer
Dim i As Integer
    ReDim headers(elements - 1)
    ReDim lengths(elements - 1)
    For i = 0 To elements - 1
        Get hFile, RESOffset + &HA + i * LENGTH + 2 + 1, lengths(i)
        Get hFile, RESOffset + &HA + i * LENGTH + 1, offset
        ReDim headers(i).data((lengths(i) * shiftCount))
        If offset < 0 Then
            zw = 2 * 32768 + offset
        Else
            zw = offset
        End If
        zw = zw * shiftCount + 1
        Get hFile, zw, headers(i).data
        headers(i).data(18) = &H16
    Next i
    GetIconHeaders = headers
End Function

Public Function GetStringtable() As String()
Dim zw As Long
Dim count As Integer
Dim erg() As String
Dim StringTable As Integer
Dim b As Byte
Dim bArr() As Byte
Dim s As String
Dim offset As Integer
    ReDim erg(elements - 1)
    Get hFile, PEOffset + &H26 + 1, StringTable
    offset = StringTable + PEOffset
    Get hFile, offset + 1, b
    ReDim bArr(b - 1)
    Seek hFile, offset + 1 + 1
    'Steht da ein "ICL"?
    s = Input(b, hFile)
    If s <> "ICL" Then Exit Function
    zw = offset + b + 1
    Get hFile, zw + 1, b
    Do
        erg(count) = Input(b, hFile)
        count = count + 1
        zw = zw + b + 1
        Get hFile, zw + 1, b
    Loop Until b = 0
    GetStringtable = erg
End Function

Public Function GetNames() As String()
Dim s() As String
Dim i As Integer
ReDim s(elements - 1)
    For i = 0 To elements - 1
        s(i) = iconNames(i) & "(" & iconHeaders(i).data(6) & "x" & iconHeaders(i).data(7) & ")"
    Next i
    GetNames = s
End Function


Public Sub SaveIcon(idx As Integer, file As String)
Dim handle As Long
    handle = FreeFile
    Open file For Output As handle
    Close handle
    handle = FreeFile
    Open file For Binary As handle
    Put handle, , icons(idx).data
    Close handle
End Sub
