VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "ICL"
   ClientHeight    =   3645
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4470
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3645
   ScaleWidth      =   4470
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'Fenstermitte
   Begin MSComDlg.CommonDialog cdgOpen 
      Left            =   4170
      Top             =   540
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.ListBox lstColorDepth 
      Height          =   1425
      Left            =   210
      TabIndex        =   4
      Top             =   2040
      Width           =   1425
   End
   Begin VB.ListBox lstIconName 
      Height          =   1425
      Left            =   210
      TabIndex        =   3
      Top             =   630
      Width           =   1425
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "ffnen"
      Height          =   285
      Left            =   3450
      TabIndex        =   2
      Top             =   270
      Width           =   795
   End
   Begin VB.TextBox txtFile 
      Height          =   255
      Left            =   210
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   300
      Width           =   3195
   End
   Begin VB.PictureBox picImageBackground 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   2820
      Left            =   1650
      ScaleHeight     =   188
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   174
      TabIndex        =   0
      Top             =   630
      Width           =   2610
      Begin VB.PictureBox picImage 
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'Kein
         Height          =   2325
         Left            =   210
         ScaleHeight     =   2325
         ScaleWidth      =   2145
         TabIndex        =   6
         Top             =   240
         Width           =   2145
      End
   End
   Begin VB.Label Label1 
      Caption         =   "ICL-Datei Pfad:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   210
      TabIndex        =   5
      Top             =   90
      Width           =   1905
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Klassenmodul einbinden
  Dim ICL As clsICL

Private Sub cmdOpen_Click()
    Dim i As Long

    ' Klassenmodul einbinden
      Set ICL = New clsICL
      
    ' Alter Pfad von cdgOpen lschen
      cdgOpen.Filename = vbNullString
      
    ' Filter fr cdgOpen einstellen
      cdgOpen.Filter = "ICL Dateien (*.icl)|*.icl"
    
    ' Formular ffnen anzeigen
      cdgOpen.ShowOpen
      
    ' berprfen ob Abbrechen geklickt wurde
      If cdgOpen.Filename = vbNullString Then
        ' Sub beenden
          Exit Sub
      End If
    
    ' Filname in Textbox schreiben
      txtFile.Text = cdgOpen.Filename
    
    ' Pfad der ICL-Datei den Klassenmodule nergeben
      ICL.Filename = cdgOpen.Filename
    
    ' Daten einlesen
      Call ICL.ReadLibrary

    ' Listbox lschen
      lstIconName.Clear
      
    ' Alle Icon-Namen in einer Liste auflisten
      For i = 1 To ICL.IconCount
        lstIconName.AddItem ICL.IconName(i)
      Next i
      
    ' Ersten Icon auswhlen
      lstIconName.ListIndex = 0
End Sub

Private Sub lstColorDepth_Click()
    ' Icon im Picturebox laden
      Set Me.picImage = ICL.IconPicture(picImage.hDC, lstIconName.ListIndex + 1, _
                        lstColorDepth.ListIndex + 1)
End Sub

Private Sub lstIconName_Click()
    Dim i As Long
    
    ' Listbox lschen
      lstColorDepth.Clear
    
    'Allen Breiten, Hhen und Farbtiefen anzeigen
        For i = 1 To ICL.ImageCount(lstIconName.ListIndex + 1)
            lstColorDepth.AddItem ICL.ImageWidth(lstIconName.ListIndex + 1, i) & "x" & _
                                    ICL.ImageHeight(lstIconName.ListIndex + 1, i) & ", " & _
                                    ICL.ColorDepth(lstIconName.ListIndex + 1, i) & "-bit"
        Next i
    
    ' Ersten Eintrag auswhlen
      lstColorDepth.ListIndex = 0
End Sub
